import java.util.Collections;
import java.util.List;

import net.christopherschultz.util.zipcode.ZipCode;
import net.christopherschultz.util.zipcode.ZipCodeRegistry;

public class Distance
{
    public static void main(String[] args)
        throws Exception
    {
        ZipCodeRegistry registry = ZipCodeRegistry.getInstance();

        ZipCode zip21210 = registry.getNearestMatch(21210);
        ZipCode zip21108 = registry.getNearestMatch(21108);

        System.out.println("21210: " + "(" + zip21210.getLatitude()
                           + ", " + zip21210.getLongitude() + ")");

        System.out.println("21108: " + "(" + zip21108.getLatitude()
                           + ", " + zip21108.getLongitude() + ")");

        System.out.println("Arc length: (from API)  " + zip21210.getArcLength(zip21108));

        System.out.println("Arc length: (from zips) "
                           + ZipCode.arc_length(zip21210.getLatitude(),
                                                zip21210.getLongitude(),
                                                zip21108.getLatitude(),
                                                zip21108.getLongitude()));

        System.out.println("Arc length: (manual)    "
                           + ZipCode.arc_length(39.352496,
                                                -76.634523,
                                                39.099957,
                                                -76.621146));


        System.out.println("Distance is "
                           + zip21210.getDistanceInMiles(zip21108)
                           + " between " + zip21210
                           + " and " + zip21108);


        // gross
        System.out.println(ZipCode.arc_length(39.3, -76.6, 39.0, -76.6) * 3956.0);
        // specific
        System.out.println(ZipCode.arc_length(39.352496, -76.624523, 39.099957, -76.621146) * 3956.0);

        System.out.println("manual: "
                           + (ZipCode.arc_length(39.352496,
                                                -76.624523,
                                                39.099957,
                                                -76.621146)
                           * 3956.0));

    }
}
